package com.yaohun.aurechargedata.api;

import com.yaohun.aurechargedata.Main;
import com.yaohun.aurechargedata.data.PlayerData;
import com.yaohun.aurechargedata.manage.RechargeManage;
import com.yaohun.aurechargedata.util.TimeType;
import org.bukkit.configuration.file.FileConfiguration;

public abstract class RechargeAPI {

    public static void setRechargeData(String name, int money) {
        RechargeManage manage = Main.rechargeManage;  // 获取充值管理实例
        PlayerData dataAPI = manage.getPlayerData(name);  // 获取玩家的充值数据实例
        // 设置玩家的每日、每月和年度充值数据为指定金额
        dataAPI.setValueData(TimeType.Daily, money);  // 设置每日充值数据
        dataAPI.setValueData(TimeType.Monthly, money);  // 设置每月充值数据
        dataAPI.setValueData(TimeType.Annual, money);  // 设置年度充值数据
    }
    // 增加累积充值金额
    public static void addRechargeData(String name, int money) {
        RechargeManage manage = Main.rechargeManage;  // 获取充值管理实例
        PlayerData dataAPI = manage.getPlayerData(name);  // 获取玩家的充值数据实例
        // 向玩家的每日、每月和年度充值数据中添加指定金额
        dataAPI.addValueData(TimeType.Daily, money);  // 增加每日充值数据
        dataAPI.addValueData(TimeType.Monthly, money);  // 增加每月充值数据
        dataAPI.addValueData(TimeType.Annual, money);  // 增加年度充值数据
    }
    public static void takeRechargeData(String name, int money) {
        RechargeManage manage = Main.rechargeManage;  // 获取充值管理实例
        PlayerData dataAPI = manage.getPlayerData(name);  // 获取玩家的充值数据实例
        // 减少玩家的每日、每月和年度充值数据
        int currentDaily = dataAPI.getValueData(TimeType.Daily);
        if (currentDaily >= money) {
            dataAPI.setValueData(TimeType.Daily, currentDaily - money);  // 减少每日充值数据
        } else {
            dataAPI.setValueData(TimeType.Daily, 0);  // 如果减少金额大于当前累积值，设为0
        }
        int currentMonthly = dataAPI.getValueData(TimeType.Monthly);
        if (currentMonthly >= money) {
            dataAPI.setValueData(TimeType.Monthly, currentMonthly - money);  // 减少每月充值数据
        } else {
            dataAPI.setValueData(TimeType.Monthly, 0);  // 如果减少金额大于当前累积值，设为0
        }
        int currentAnnual = dataAPI.getValueData(TimeType.Annual);
        if (currentAnnual >= money) {
            dataAPI.setValueData(TimeType.Annual, currentAnnual - money);  // 减少年度充值数据
        } else {
            dataAPI.setValueData(TimeType.Annual, 0);  // 如果减少金额大于当前累积值，设为0
        }
    }

    // 增加累积充值金额
    public static void addRechargeData(String name,int money,TimeType timeType) {
        RechargeManage manage = Main.rechargeManage;  // 获取充值管理实例
        PlayerData dataAPI = manage.getPlayerData(name);  // 获取玩家的充值数据实例
        // 根据时间类型向玩家的充值数据中添加指定金额
        if (timeType == TimeType.Daily) {
            dataAPI.addValueData(TimeType.Daily, money);  // 增加每日充值数据
            dataAPI.addValueData(TimeType.Monthly, money);  // 增加每月充值数据
            dataAPI.addValueData(TimeType.Annual, money);  // 增加年度充值数据
        } else if (timeType == TimeType.Monthly) {
            dataAPI.addValueData(TimeType.Monthly, money);  // 增加每月充值数据
            dataAPI.addValueData(TimeType.Annual, money);  // 增加年度充值数据
        } else if (timeType == TimeType.Annual) {
            dataAPI.addValueData(TimeType.Annual, money);  // 增加年度充值数据
        }
    }

    public void setRechargeData(String name, int money, TimeType timeType) {
        RechargeManage manage = Main.rechargeManage;  // 获取充值管理实例
        PlayerData dataAPI = manage.getPlayerData(name);  // 获取玩家的充值数据实例
        // 根据时间类型设置玩家的累积充值数据
        if (timeType == TimeType.Daily) {
            dataAPI.setValueData(TimeType.Daily, money);  // 设置每日累积充值数据
            dataAPI.setValueData(TimeType.Monthly, money);  // 设置每月累积充值数据
            dataAPI.setValueData(TimeType.Annual, money);  // 设置年度累积充值数据
        } else if (timeType == TimeType.Monthly) {
            dataAPI.setValueData(TimeType.Monthly, money);  // 设置每月累积充值数据
            dataAPI.setValueData(TimeType.Annual, money);  // 设置年度累积充值数据
        } else if (timeType == TimeType.Annual) {
            dataAPI.setValueData(TimeType.Annual, money);  // 设置年度累积充值数据
        }
    }

    public void takeRechargeData(String name, int money, TimeType timeType) {
        RechargeManage manage = Main.rechargeManage;  // 获取充值管理实例
        PlayerData dataAPI = manage.getPlayerData(name);  // 获取玩家的充值数据实例
        // 根据时间类型减少玩家的累积充值数据
        if (timeType == TimeType.Daily) {
            int currentDaily = dataAPI.getValueData(TimeType.Daily);
            if (currentDaily >= money) {
                dataAPI.setValueData(TimeType.Daily, currentDaily - money);  // 减少每日累积充值数据
            } else {
                dataAPI.setValueData(TimeType.Daily, 0);  // 如果减少金额大于当前累积值，设为0
            }
            int currentMonthly = dataAPI.getValueData(TimeType.Monthly);
            if (currentMonthly >= money) {
                dataAPI.setValueData(TimeType.Monthly, currentMonthly - money);  // 减少每月累积充值数据
            } else {
                dataAPI.setValueData(TimeType.Monthly, 0);  // 如果减少金额大于当前累积值，设为0
            }
            int currentAnnual = dataAPI.getValueData(TimeType.Annual);
            if (currentAnnual >= money) {
                dataAPI.setValueData(TimeType.Annual, currentAnnual - money);  // 减少年度累积充值数据
            } else {
                dataAPI.setValueData(TimeType.Annual, 0);  // 如果减少金额大于当前累积值，设为0
            }
        } else if (timeType == TimeType.Monthly) {
            int currentMonthly = dataAPI.getValueData(TimeType.Monthly);
            if (currentMonthly >= money) {
                dataAPI.setValueData(TimeType.Monthly, currentMonthly - money);  // 减少每月累积充值数据
            } else {
                dataAPI.setValueData(TimeType.Monthly, 0);  // 如果减少金额大于当前累积值，设为0
            }
            int currentAnnual = dataAPI.getValueData(TimeType.Annual);
            if (currentAnnual >= money) {
                dataAPI.setValueData(TimeType.Annual, currentAnnual - money);  // 减少年度累积充值数据
            } else {
                dataAPI.setValueData(TimeType.Annual, 0);  // 如果减少金额大于当前累积值，设为0
            }
        } else if (timeType == TimeType.Annual) {
            int currentAnnual = dataAPI.getValueData(TimeType.Annual);
            if (currentAnnual >= money) {
                dataAPI.setValueData(TimeType.Annual, currentAnnual - money);  // 减少年度累积充值数据
            } else {
                dataAPI.setValueData(TimeType.Annual, 0);  // 如果减少金额大于当前累积值，设为0
            }
        }
    }
}
